#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_ActivityKillCrabLotteryCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_ActivityKillCrabLotteryCFG> Fish_ActivityKillCrabLotteryCFG::msSingleton(nullptr);

int Fish_ActivityKillCrabLotteryCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_ActivityKillCrabLotteryCFGData* Fish_ActivityKillCrabLotteryCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_ActivityKillCrabLotteryCFGData>& Fish_ActivityKillCrabLotteryCFG::GetMapData()
{
	return mMapData;
}

void Fish_ActivityKillCrabLotteryCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_ActivityKillCrabLotteryCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_ActivityKillCrabLotteryCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mCostItemCount = element->IntAttribute("CostItemCount");
		{
			const char* AwardItemIDs = element->Attribute("AwardItemIDs");
			std::vector<std::string> vecAwardItemIDs;
			boost::split(vecAwardItemIDs, AwardItemIDs, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemIDs.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemIDs[i].c_str(), &temp))
				{
					data.mAwardItemIDs.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemCounts = element->Attribute("AwardItemCounts");
			std::vector<std::string> vecAwardItemCounts;
			boost::split(vecAwardItemCounts, AwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemCounts[i].c_str(), &temp))
				{
					data.mAwardItemCounts.push_back(temp);
				}
			}
		}
		{
			const char* AwardWeight = element->Attribute("AwardWeight");
			std::vector<std::string> vecAwardWeight;
			boost::split(vecAwardWeight, AwardWeight, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardWeight.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardWeight[i].c_str(), &temp))
				{
					data.mAwardWeight.push_back(temp);
				}
			}
		}
		data.mHarmValueMin = element->IntAttribute("HarmValueMin");
		data.mHarmValueMax = element->IntAttribute("HarmValueMax");
		{
			const char* DisplayLabel = element->Attribute("DisplayLabel");
			std::vector<std::string> vecDisplayLabel;
			boost::split(vecDisplayLabel, DisplayLabel, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecDisplayLabel.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecDisplayLabel[i].c_str(), &temp))
				{
					data.mDisplayLabel.push_back(temp);
				}
			}
		}
		{
			const char* ShowAwardItemIDs = element->Attribute("ShowAwardItemIDs");
			std::vector<std::string> vecShowAwardItemIDs;
			boost::split(vecShowAwardItemIDs, ShowAwardItemIDs, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecShowAwardItemIDs.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecShowAwardItemIDs[i].c_str(), &temp))
				{
					data.mShowAwardItemIDs.push_back(temp);
				}
			}
		}
		{
			const char* ShowAwardItemCounts = element->Attribute("ShowAwardItemCounts");
			std::vector<std::string> vecShowAwardItemCounts;
			boost::split(vecShowAwardItemCounts, ShowAwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecShowAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecShowAwardItemCounts[i].c_str(), &temp))
				{
					data.mShowAwardItemCounts.push_back(temp);
				}
			}
		}
		data.mDisplayICON = element->Attribute("DisplayICON");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_ActivityKillCrabLotteryCFG::Load()
{
	Load("../Config/Fish_ActivityKillCrabLotteryCFG.xml");
}

Fish_ActivityKillCrabLotteryCFG* Fish_ActivityKillCrabLotteryCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_ActivityKillCrabLotteryCFG());
	}
	return msSingleton.get();
}
